var Exp00100_lancamentoExpedicaoItem_Controller = function(General, templateManager, ScreenService, Exp00100_lancamentoExpedicaoItem_Service, ZHPromise, ZhFilterPreferences, MessageService) {

    this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilialLogadaFilter(widget);
            this.filterAdjustment();
        }.bind(this)); 
    }; 

    this.setFilialLogadaFilter = function (widget){
        Exp00100_lancamentoExpedicaoItem_Service.getFilialLogada().then(function(filialLogada) {
            if (filialLogada[0]) {
                // var widget = templateManager.container.getWidget('expedicaoItem');
                templateManager.container.getActiveWidget().currentRow.CDFILIAL = filialLogada[0].CDFILIAL;
                templateManager.container.getActiveWidget().currentRow.NMFILIAL = filialLogada[0].NMFILIAL;
                
                // this.setSerieFilter(widget);
                Exp00100_lancamentoExpedicaoItem_Service.retornaEmpresa(filialLogada[0].CDEMPRESA).then(function(empresa) {
                    
                    templateManager.container.getActiveWidget().currentRow.CDEMPRESA = empresa[0].CDEMPRESA;
                    templateManager.container.getActiveWidget().currentRow.NMEMPRESA = empresa[0].NMEMPRESA;
                }.bind(this));
            } else {
                ScreenService.showMessage('Erro ao buscar Filial Logada, escolha manualmente.');
            }
        }.bind(this));
    };
    
    this.filterAdjustment = function (){
        // Exp00100_lancamentoExpedicaoItem_Service.getFilialLogada().then(function(filialLogada) {
        //     var cdfilial = filialLogada[0].CDFILIAL;
        //     var widget = templateManager.container.getWidget('expedicaoItem');
        //     var widgetFiltro = templateManager.container.getActiveWidget();
        //     if (widgetFiltro && widgetFiltro.currentRow.CDFILIAL && filialLogada[0].CDFILIAL !== widgetFiltro.currentRow.CDFILIAL) {
        //         cdfilial = widgetFiltro.currentRow.CDFILIAL;
        //     }
        //     var filter = [
        //         {
        //             "name": "CDFILIAL",
        //             "operator": "=",
        //             "value": cdfilial
        //         }
        //     ];
        //     // widgetFiltro.currentRow.CDSERIE = '';
        //     // widgetFiltro.currentRow.DSSERIE = '';
        //     // this.setSerieFilter2(filter);
        //     General.callRestEngine('ped#/crud/parampedido', "FilterData", filter).then(function(callback){
        //         var params = callback.dataset.parampedido;
        //         // widget.transportadora = params[0].NRINSJURTRAN;
        //         if (params[0] && params[0].IDOBRTPOPPED == 'N'){
        //             widget.getField('NMTIPOOPER').requiredParam = true;
        //             widgetFiltro.getField('NMTIPOOPER').validations = {
        //                 required: true
        //             };
        //             widgetFiltro.getField('NMTIPOOPER').reload();
        //         } else if (params[0]){
        //             widget.getField('NMTIPOOPER').requiredParam = false;
        //             delete widgetFiltro.getField('NMTIPOOPER').validations;
        //         } else {
        //             ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial escolhida.');
        //         }
        //     }.bind(this)).catch(function(callback){
        //         ScreenService.showMessage(callback.dataset.error);
        //     });
        // }.bind(this)).catch(function(callback){
        //     ScreenService.showMessage(callback.dataset.error);
        // }.bind(this));
    };
    
    this.setDataSourceFilterApply = function(args){
        if(templateManager.container.getActiveWidget().isValid()){
            // var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter = [];
            
            dataSourceFilter.push(
                    {
                        "name": "P_CDFILIAL",
                        "operator": "=",
                        "value": "0007"
                    },
                    {
                        "name": "P_IDORIGDESTOP",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "P_TPOPER",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "P_ROTALISTA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "P_TROTALISTA",
                        "operator": "=",
                        "value": "T"
                    },
                    {
                        "name": "P_DIAROTA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "P_TDIAROTA",
                        "operator": "=",
                        "value": "T"
                    },
                    {
                        "name": "P_CDROTAFILI",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "P_TCDROTAFILI",
                        "operator": "=",
                        "value": "T"
                    },
                    {
                        "name": "P_DTPEDIDODE",
                        "operator": "=",
                        "value": "01/05/2022"
                    },
                    {
                        "name": "P_DTPEDIDOATE",
                        "operator": "=",
                        "value": "31/05/2022"
                    }
                );
            
            
            /*if (rowPopup.TIPOFILTRO == 'L') {
                var listaPED = '_'+rowPopup.NRPEDIDO.join('_')+'_';
               // var lista = listaPED.replace(/\,/g, '_');
                //var newListaPED = '_'+lista+'_';

                dataSourceFilter.push(
                    {
                        "name": "LNRPEDIDO",
                        "operator": "=",
                        "value": listaPED
                    },
                    {
                        "name": "NRPEDIDOINI",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "NRPEDIDOFIN",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else if (rowPopup.TIPOFILTRO == 'I') {
                dataSourceFilter.push(
                    {
                        "name": "NRPEDIDOINI",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOINI
                    },
                    {
                        "name": "NRPEDIDOFIN",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOFIN
                    },
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else if (rowPopup.TIPOFILTRO == 'T' || !rowPopup.TIPOFILTRO) {
                dataSourceFilter.push(
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.CDCLIENTE && rowPopup.CDCLIENTE.length != 0) {
                var listaCLIENTE = '_'+rowPopup.CDCLIENTE.join('_')+'_';
                dataSourceFilter.push(
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": listaCLIENTE
                    },
                    {
                        "name": "TCDCLIENTE",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDCLIENTE",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.CDVENDEDOR && rowPopup.CDVENDEDOR.length != 0) {
                var listaVENDEDOR = '_'+rowPopup.CDVENDEDOR.join('_')+'_';
                dataSourceFilter.push(
                    {
                        "name": "CDVENDEDOR",
                        "operator": "=",
                        "value": listaVENDEDOR
                    },
                    {
                        "name": "TCDVENDEDOR",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDVENDEDOR",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.DTPEDIDO && rowPopup.DTPEDIDO.start && rowPopup.DTPEDIDO.end) {
                dataSourceFilter.push(
                    {
                        "name": "DTPEDIDOINI",
                        "operator": "=",
                        "value": rowPopup.DTPEDIDO.start
                    },
                    {
                        "name": "DTPEDIDOFIN",
                        "operator": "=",
                        "value": rowPopup.DTPEDIDO.end
                    },
                    {
                        "name": "TDTPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TDTPEDIDO",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }
            
            if (rowPopup.CDTIPOOPER){
                dataSourceFilter.push(
                    {
                        "name": "CDTIPOOPER",
                        "operator": "=",
                        "value": rowPopup.CDTIPOOPER
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDTIPOOPER",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.DTENTPED && rowPopup.DTENTPED.start && rowPopup.DTENTPED.end) {
                dataSourceFilter.push(
                    {
                        "name": "DTENTPEDINI",
                        "operator": "=",
                        "value": rowPopup.DTENTPED.start
                    },
                    {
                        "name": "DTENTPEDFIN",
                        "operator": "=",
                        "value": rowPopup.DTENTPED.end
                    },
                    {
                        "name": "TDTENTPED",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TDTENTPED",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }
            

            for (var i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'CDSERIE') {
                    args.owner.CDSERIE = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            for (i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'CDEMPRESA') {
                    args.owner.CDEMPRESA = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            for (i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'TIPOFILTRO') {
                    args.owner.CDEMPRESA = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }*/
            
            args.owner.dataSourceFilter = dataSourceFilter;
            
            args.owner.container.getWidget('expedicaoItem').reload();
        }
    };
    
    this.setDefaultTab = function(){
        var widget = templateManager.container.getWidget('transportadora');
        widget.activate();
        widget.reload();
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Exp00100_lancamentoExpedicaoItem_Controller', Exp00100_lancamentoExpedicaoItem_Controller);
});